/*======================================================================*
 *  Module .............libbtsystem
 *  File ...............globals.h
 *  Author .............Traveler Hauptman
 *  Creation Date ......Nov 23, 2002 
 *                                                                      *
 *  ******************************************************************  *
 *                                                                      
 *  NOTES:                                                              
 *  Global variables
 *  Useful defines
 *  Wrapper functions                  
 *                                                                      
 *  REVISION HISTORY:                                                   
 *  021203 - TH - File created                                          
 *                                                                      
 *======================================================================*/

 /*! \file globals.h  
    \brief Global variables, useful defines, etc
    
    
*/

#ifndef _GLOBALS_H
#define _GLOBALS_H

/********************* Defines **********************/
#define EPOCH                 500000L           ///< epoch in nanosecond; should be 499504, but ClockPeriod() errors with anything less than 500000
#define SAMPLETIME            999008L          ///<  DT in nanoseconds - an integer multiple of EPOCH     

#define TWOPI 6.283185

#define fer(_x_,_y_) for (_x_ = 0;_x_ < _y_;_x_++)
#define Border(Value,Min,Max)  (Value<Min)?Min:((Value>Max)?Max:Value)
#endif/* _GLOBALS_H*/
/********************* Defines **********************/
