/*======================================================================*
 *  Module .............libbtwam
 *  File ...............Dynamics.h
 *  Author .............Sam Clanton
 *  Creation Date ......Q3 2004
 *  Addt'l Authors......Traveler Hauptman
 *                                                                      *
 *  ******************************************************************  *
 *                                                                      *
 *  NOTES:
 *
 *  REVISION HISTORY:
 *    Dec 17, 2004: TH
 *      Splitting libbt into libbtsystem & libbtwam. Adjust file names
 *      to support this. btwam -> btwamctl, btdriver -> btwam
 *                                                                      *
 *======================================================================*/

#ifndef __DYNAMICS_H__
#define __DYNAMICS_H__


#include "Kinematics.h"

typedef struct {

  int DOF;
  double LinkMasses[MAXDOF];
  double LinkCOGLoc[MAXDOF][3];

} WAMDynamics;






void GravityAndTipForceTorques(WAMDynamics *wamDyn, WAMKinematics *wamKin, wam_vector *joint_angles, wam_vector *joint_vel, wam_vector *joint_acc, WAMLoc *tipforce, wam_vector *torques, int gravityon);
//void DealWithStuffInSpace(wam_vector *inputAngles, WAMLoc *tipforce);
//void InitBlock(WAMLoc *c1, WAMLoc *c2, double visc);


#endif

/*======================================================================*
 *                                                                      *
 *          Copyright (c) 2003, 2004 Barrett Technology, Inc.           *
 *                        625 Mount Auburn St                           *
 *                    Cambridge, MA  02138,  USA                        *
 *                                                                      *
 *                        All rights reserved.                          *
 *                                                                      *
 *  ******************************************************************  *
 *                            DISCLAIMER                                *
 *                                                                      *
 *  This software and related documentation are provided to you on      *
 *  an as is basis and without warranty of any kind.  No warranties,    *
 *  express or implied, including, without limitation, any warranties   *
 *  of merchantability or fitness for a particular purpose are being    *
 *  provided by Barrett Technology, Inc.  In no event shall Barrett     *
 *  Technology, Inc. be liable for any lost development expenses, lost  *
 *  lost profits, or any incidental, special, or consequential damage.  *
 *======================================================================*/
