/*======================================================================*
 *  Module .............libbtwam
 *  File ...............Kinematics.h
 *  Author .............Sam Clanton
 *  Creation Date ......Q3 2004
 *  Addt'l Authors......Traveler Hauptman
 *                                                                      *
 *  ******************************************************************  *
 *                                                                      *
 *  NOTES:
 *
 *  REVISION HISTORY:
 *    Dec 17, 2004: TH
 *      Splitting libbt into libbtsystem & libbtwam. Adjust file names
 *      to support this. btwam -> btwamctl, btdriver -> btwam
 *                                                                      *
 *======================================================================*/

#ifndef __KINEMATICS_H__
#define __KINEMATICS_H__

#include "btwamctl.h"

#define MASSTEST


#ifdef MASSTEST
#define MAXDOF 8
#else
#define MAXDOF 4
#endif

typedef struct {

  double pos[3];
  double angle[3];

} WAMLoc;


typedef struct {

  double transforms[MAXDOF][16];
  double As[MAXDOF];
  double Ds[MAXDOF];
  double Alphas[MAXDOF];
  int dof;

} WAMKinematics;



void findDHtransform_deltaTheta(WAMKinematics *wamKin, wam_vector *inputAngles);

void initLinkTransform(double alpha, double a, double theta, double d, double *transform);

void InitKinematics(WAMKinematics *wamKin, int dof);





#endif

/*======================================================================*
 *                                                                      *
 *          Copyright (c) 2003, 2004 Barrett Technology, Inc.           *
 *                        625 Mount Auburn St                           *
 *                    Cambridge, MA  02138,  USA                        *
 *                                                                      *
 *                        All rights reserved.                          *
 *                                                                      *
 *  ******************************************************************  *
 *                            DISCLAIMER                                *
 *                                                                      *
 *  This software and related documentation are provided to you on      *
 *  an as is basis and without warranty of any kind.  No warranties,    *
 *  express or implied, including, without limitation, any warranties   *
 *  of merchantability or fitness for a particular purpose are being    *
 *  provided by Barrett Technology, Inc.  In no event shall Barrett     *
 *  Technology, Inc. be liable for any lost development expenses, lost  *
 *  lost profits, or any incidental, special, or consequential damage.  *
 *======================================================================*/

