/*======================================================================*
 *  Module .............libbtwam
 *  File ...............MatrixMath.c
 *  Author .............Sam Clanton
 *  Creation Date ......Q3 2004
 *  Addt'l Authors......Traveler Hauptman
 *                                                                      *
 *  ******************************************************************  *
 *                                                                      *
 *  NOTES:
 *
 *  REVISION HISTORY:
 *    Dec 17, 2004: TH
 *      Splitting libbt into libbtsystem & libbtwam. Adjust file names
 *      to support this. btwam -> btwamctl, btdriver -> btwam
 *                                                                      *
 *======================================================================*/
#include <math.h>
#include <syslog.h>
#include "MatrixMath.h"

#define PI 3.14159

/* yes these are as stupid and braindead as they seem */


inline double atan2(double arg1, double arg2)
{
  /* returns angle from -PI to PI */

  if(arg2 > 0.0)
    {
      if(arg1 >= 0.0)
	{
	  return(atan(arg1 / arg2));
	}
      else
	{
	  return(-1 * atan(arg1 / arg2));
	}
    }
  
  if(arg2 < 0.0)
    {
      if(arg1 >= 0.0)
	{
	  return(PI - atan(arg1 / arg2));
	}
      else
	{
	  return( -1 * (PI - atan(arg1 / arg2)));
	}
    }


  /* x = 0 */
  if(arg1 > 0)
    return(PI/2);
  else
    return(-PI/2);
  
}

void mtrx_mult(double *dest, double *mtrx1, int rows1, int cols1, double *mtrx2, int rows2, int cols2)
{
  /* dest had better be allocated right */
  static int i,j,k;
  static double sum;

  if(cols1 != rows2)
    perror("invalid matrix multiplication");
  
  for(i=0;i<rows1;i++)
    for(j=0;j<cols2;j++)
      {
	sum = 0.0;

	for(k=0;k<cols1;k++)
	  sum += *(mtrx1 + i * cols1 + k) * *(mtrx2 + j + k * cols2);


	*(dest + cols2 * i + j) = sum;



      }
  


}

void mtrx_invert3(double *input, double  *output)
{


}



void mtrx_cpy(double *input, double *output, int rows, int columns)
{
  static int els;
  static int i;
  els = rows * columns;

  for(i=0;i<els;i++)
    {
      output[i] = input[i];

    }
  
	


}

void mtrx_print(double *input, int rows, int columns, char *message)
{
  mtrx_printd(stdout, input, rows, columns, message);
}

void mtrx_log(double *input, int rows, int columns, char *message)
{

  int i,j;

  char foo[128];

  syslog(LOG_ERR, "%s", message);
  for(i=0;i<rows;i++)
    {
      for(j=0;j<columns;j++)
	{
	  sprintf(foo+j*9,"%f ", *(input + i*columns + j));
	}
      
      syslog(LOG_ERR, "%s", foo);
    }

}
void mtrx_printd(FILE *dest, double *input, int rows, int columns, char *message)

{
  int i,j;

  fprintf(dest,"%s\n", message);

  for(i=0;i<rows;i++)
    {
      for(j=0;j<columns;j++)
	{
	  fprintf(dest,"%f ", *(input + i*columns + j));
	}
      fprintf(dest,"\n");
    }


}

void mtrx_transpose(double *input, double *output, int inrows, int incols)
{
  static int i,j;

  for(i=0;i<inrows;i++)
    for(j=0;j<incols;j++)
      {
	*(output+j*inrows+i) = *(input+i*incols+j);
      }

}
inline void cross(double *dest, double *vec1, double *vec2)
{

  dest[0] = vec1[1] * vec2[2] - vec1[2] * vec2[1];
  dest[1] = vec1[2] * vec2[0] - vec1[0] * vec2[2];
  dest[2] = vec1[0] * vec2[1] - vec1[1] * vec2[0];



}

inline void dot(double *dest, double *vec1, double *vec2)
{

  (*dest) = vec1[0] * vec2[0] + vec1[1] * vec2[1] + vec1[2] * vec2[2]; 


}
/*======================================================================*
 *                                                                      *
 *          Copyright (c) 2003, 2004 Barrett Technology, Inc.           *
 *                        625 Mount Auburn St                           *
 *                    Cambridge, MA  02138,  USA                        *
 *                                                                      *
 *                        All rights reserved.                          *
 *                                                                      *
 *  ******************************************************************  *
 *                            DISCLAIMER                                *
 *                                                                      *
 *  This software and related documentation are provided to you on      *
 *  an as is basis and without warranty of any kind.  No warranties,    *
 *  express or implied, including, without limitation, any warranties   *
 *  of merchantability or fitness for a particular purpose are being    *
 *  provided by Barrett Technology, Inc.  In no event shall Barrett     *
 *  Technology, Inc. be liable for any lost development expenses, lost  *
 *  lost profits, or any incidental, special, or consequential damage.  *
 *======================================================================*/
