/*======================================================================*
 *  Module .............libbtwam
 *  File ...............MatrixMath.h
 *  Author .............Sam Clanton
 *  Creation Date ......Q3 2004
 *  Addt'l Authors......Traveler Hauptman
 *                                                                      *
 *  ******************************************************************  *
 *                                                                      *
 *  NOTES:
 *
 *  REVISION HISTORY:
 *    Dec 17, 2004: TH
 *      Splitting libbt into libbtsystem & libbtwam. Adjust file names
 *      to support this. btwam -> btwamctl, btdriver -> btwam
 *                                                                      *
 *======================================================================*/
#ifndef __SAMMATRIXMATH_H__
#define __SAMMATRIXMATH_H__

#include <stdio.h>

inline void mtrx_mult(double *dest, double *mtrx1, int rows1, int cols1, double *mtrx2, int rows2, int cols2);
inline void mtrx_cpy(double *input, double *output, int rows, int columns);
inline void mtrx_print(double *input, int rows, int columns, char *message);
inline void mtrx_log(double *input, int rows, int columns, char *message);
inline void mtrx_printd(FILE *dest,double *input, int rows, int columns, char *message);
inline void mtrx_transpose(double *input, double *output, int inrows, int incolumns);
inline double atan2(double arg1, double arg2);
inline void dot(double *dest, double *vec1, double *vec2);
inline void cross(double *dest, double*vec1, double *vec2);
inline void matrix_invert3(double *input, double *output);


#endif

/*======================================================================*
 *                                                                      *
 *          Copyright (c) 2003, 2004 Barrett Technology, Inc.           *
 *                        625 Mount Auburn St                           *
 *                    Cambridge, MA  02138,  USA                        *
 *                                                                      *
 *                        All rights reserved.                          *
 *                                                                      *
 *  ******************************************************************  *
 *                            DISCLAIMER                                *
 *                                                                      *
 *  This software and related documentation are provided to you on      *
 *  an as is basis and without warranty of any kind.  No warranties,    *
 *  express or implied, including, without limitation, any warranties   *
 *  of merchantability or fitness for a particular purpose are being    *
 *  provided by Barrett Technology, Inc.  In no event shall Barrett     *
 *  Technology, Inc. be liable for any lost development expenses, lost  *
 *  lost profits, or any incidental, special, or consequential damage.  *
 *======================================================================*/


