/*======================================================================*
 *  Module .............libbtwam
 *  File ...............btwam.h
 *  Author .............Sam Clanton
 *  Creation Date ......Q3 2004
 *  Addt'l Authors......Traveler Hauptman
 *                                                                      *
 *  ******************************************************************  *
 *                                                                      *
 *  NOTES:
 *
 *  REVISION HISTORY:
 *    Dec 17, 2004: TH
 *      Splitting libbt into libbtsystem & libbtwam. Adjust file names
 *      to support this. btwam -> btwamctl, btdriver -> btwam
 *                                                                      *
 *======================================================================*/

#ifndef _BTWAM_H
#define _BTWAM_H

#include "btwamctl.h"

int InitWAM(wam_struct *wamDriverDat, char *wamfile);
void CloseWAM();
SimpleCtl * GetWAMsc();
int LoadWAM(char *wamfile);
void SaveWAM(char *wamfile);
void DumpWAM2Syslog();
void WAMControlThread(void *data);

void PidWAM();
void TorqueWAM();
void PowerWAM();
void IdleWAM();

void SetWAMpos(wam_vector *wv);
void MoveWAM(wam_vector *pos, wam_vector *vel, wam_vector *acc);
void ParkWAM();

void ZeroWAM();

typedef int (*TorqueEffector)(wam_struct *, void *);

void deregisterTorqueEffector(int index);
int registerTorqueEffector(TorqueEffector torqueEffector);



#endif /*_BTWAM_H*/

/*======================================================================*
 *                                                                      *
 *          Copyright (c) 2003, 2004 Barrett Technology, Inc.           *
 *                        625 Mount Auburn St                           *
 *                    Cambridge, MA  02138,  USA                        *
 *                                                                      *
 *                        All rights reserved.                          *
 *                                                                      *
 *  ******************************************************************  *
 *                            DISCLAIMER                                *
 *                                                                      *
 *  This software and related documentation are provided to you on      *
 *  an as is basis and without warranty of any kind.  No warranties,    *
 *  express or implied, including, without limitation, any warranties   *
 *  of merchantability or fitness for a particular purpose are being    *
 *  provided by Barrett Technology, Inc.  In no event shall Barrett     *
 *  Technology, Inc. be liable for any lost development expenses, lost  *
 *  lost profits, or any incidental, special, or consequential damage.  *
 *======================================================================*/
