/*======================================================================*
 *  Module .............libbtwam
 *  File ...............newlibbt.c
 *  Author .............Sam Clanton
 *  Creation Date ......Q3 2004
 *  Addt'l Authors......Traveler Hauptman
 *                                                                      *
 *  ******************************************************************  *
 *                                                                      *
 *  NOTES:
 *
 *  REVISION HISTORY:
 *    Dec 17, 2004: TH
 *      Splitting libbt into libbtsystem & libbtwam. Adjust file names
 *      to support this. btwam -> btwamctl, btdriver -> btwam
 *                                                                      *
 *======================================================================*/
#include <syslog.h>
#include "btwam.h"
#include "newlibbt.h"



void InitHapticWAM(WAMdat *wam)
{
  int ret;


  
  ret =  InitWAM(wam->wamDriverData, "wam.dat");
  if(ret)
    {
      CloseSystem();
      closelog();
      // endwin();
      exit(0);

    }
  InitWAMKinematics(&wam->wamKin, wam->wamDriverData->num_actuators+1); // hack +1
  InitWAMDynamics(&wam->wamDyn, wam->wamDriverData->num_actuators+1);
  InitHaptics();






}
/*======================================================================*
 *                                                                      *
 *          Copyright (c) 2003, 2004 Barrett Technology, Inc.           *
 *                        625 Mount Auburn St                           *
 *                    Cambridge, MA  02138,  USA                        *
 *                                                                      *
 *                        All rights reserved.                          *
 *                                                                      *
 *  ******************************************************************  *
 *                            DISCLAIMER                                *
 *                                                                      *
 *  This software and related documentation are provided to you on      *
 *  an as is basis and without warranty of any kind.  No warranties,    *
 *  express or implied, including, without limitation, any warranties   *
 *  of merchantability or fitness for a particular purpose are being    *
 *  provided by Barrett Technology, Inc.  In no event shall Barrett     *
 *  Technology, Inc. be liable for any lost development expenses, lost  *
 *  lost profits, or any incidental, special, or consequential damage.  *
 *======================================================================*/
